/*************************************************************************
 ********************    JPrimi.java    **********************************
 *************************************************************************
 */
import java.io.*;

public class JPrimi {

	public JPrimi() {
	}

    private String calcolaNumeriPrimi(int upperLimit) {
		StringBuffer buff = new StringBuffer();
		String space = " ";
		String NL = System.getProperty("line.separator");
		int h = 0;
label:	for(int i=3; i<=upperLimit; i+=2) {
			for(int j=3; j<(i+1)/2; j+=2)
				if(i%j == 0) continue label;
			h += 1;
			buff.append(space);
			buff.append(space);
			buff.append(space);
			if(i <     10) buff.append(space);
			if(i <    100) buff.append(space);
			if(i <   1000) buff.append(space);
			if(i <  10000) buff.append(space);
			if(i < 100000) buff.append(space);
			buff.append(i);
			buff.append(space);
			if(h%7 == 0) buff.append(NL);
		}
		return buff.toString();
	}

    public void saveFile(String dir, String file, String stringa) {
		FileWriter out=null;
		File f=null;
		try{
			f=new File(dir,file);
			out=new FileWriter(f);
			out.write(stringa);
		} catch(IOException e) {
			System.out.println("SaveFile Error : " + e);
		} finally {
			try{
				if(out != null) out.close();
			} catch(IOException e) {
				System.out.println(e);
			}
		}
	}

	public static void main(String[] args) {
		int n = 200000;
		String directory = System.getProperty("user.dir");
		String file = "JPrimi.txt";
		JPrimi p = new JPrimi();
		System.out.println("Calcolo dei numeri primi tra 3 e " + n);
		System.out.println("Calcolo in corso. Attendere ...\n");
		long start = System.currentTimeMillis();
		String risultato = p.calcolaNumeriPrimi(n);
		p.saveFile(directory, file, risultato);
		long time = System.currentTimeMillis() - start;
		System.out.println("Risultati registrati nel file JPrimi.txt");
		System.out.println("\nTempo impiegato : " + time + " ms\n");
    }
}